#define _CRT_SECURE_NO_DEPRECATE
#include "LBParser.h"
#include <stdio.h>
#include <time.h>
#include <string.h>
#include "getopt.h"
#pragma comment(lib,"LBParser.lib")

void usage()
{
    printf("Usage: HTML2LRF [-t \"Book title\"] [-a \"Book Author\"] [-o output_filename] <url|path.html> [<url|path.html>...]");
}
void main(int argc, char* argv[])
{
  printf("HTML2LRF v 0.1 (c) 2006 Igor Skochinsky\n");
  char* out_fname = "test.lrf";
  char* title = "Test Book";
  char* author = "Unknown Author";
  char design_file[260];
  strcpy(design_file,argv[0]);
  char* pos = strrchr(design_file,'\\');
  if (!pos) pos = strrchr(design_file,'/');
  if (pos) pos[1] = 0;
  else design_file[0]=0;
  strcat(design_file,"DesignHorizontal.lrf");

  int ch;
  while ((ch = getopt(argc, argv, "ht:a:o:")) != -1) {
    switch (ch) {
    case 't':
      title = optarg;
      break;
    case 'a':
      author = optarg;
      break;
    case 'o':
      out_fname = optarg;
      break;
    case '?':
    case 'h':
    default:
      usage();
      return;
    }
  }
  argc -= optind;
  argv += optind;
  if (argc==0)
  {
    usage();
    return;
  }

  char bookID[17];
  time_t now = time(0);
  strftime(bookID,16,"FBENNP%m%d%H%M%S",localtime(&now));
  bookID[16]=0;
  CLBParser parser;
  parser.SetBookTitle(title);
  parser.SetBookTitle_read(title);
  parser.SetBookAuthor(author);
  parser.SetBookAuthor_read(author);
  parser.SetBookID(bookID);
  parser.SetLRFFileName(out_fname);
  parser.SetDesignFileName("DesignHorizontal.lrf");
  parser.CreateNewBook();
  //parser.AddPage("file://E:/Work/progs/Reader/LibrieToolbar/test/test.html",0,0);
  printf("Writing to %s...\n",out_fname);
  while (argc--)
  {
    printf("%s\n",*argv);
    parser.AddPage(*argv++,0,0);
  }
  printf("Finalizing...");
  parser.FinalizeBook();
  printf(" done.\n");
}
